/* test bench */
`timescale 1ns/1ps
`include "def.h"
module poco_top_sim(
input clk50,
input btn_rot, btn_north, btn_south, btn_east, btn_west,
input [3:0] sw,
output reg [7:0] led,
output lcd_rs, lcd_e, lcd_rw,
output [7:0] db);

   wire [`DATA_W-1:0] rd, dmem_rd, wd, instrd ;
   wire [`DATA_W-1:0] daddr, iaddr;
   wire north, east, west, south;
   wire dmem_we, led_we, lcd_we, we;
	
   wire rst_n;
   assign dmem_we = ~daddr[15] & we;
   assign led_we = daddr[15] & ~daddr[14] & ~daddr[13] & we;
   assign lcd_we = daddr[15] & ~daddr[14] & daddr[13] & we;
   assign rst_n = ~btn_rot;
   assign rd = daddr[15] & daddr[14] ? {8'b0, north, south, east, west, sw} : 
						dmem_rd;

   always @(negedge clk50) 
	if(led_we) led <= wd[7:0];
   assign east = btn_east;
   assign west = btn_west;
   assign south = btn_south;
   assign north = btn_north;

   poco poco_1(.clk(clk50), .rst_n(rst_n), .idatain(instrd),
               .ddatain(rd), .iaddr(iaddr), .daddr(daddr),
               .ddataout(wd), .we(we));
   imem imem_1(.clk(~clk50), .we(1'b0), .addr(iaddr[9:0]), .d(16'b0), .q(instrd));
   dmem dmem_1(.clk(~clk50), .we(dmem_we), .addr(daddr[9:0]), .d(wd), .q(dmem_rd));

   lcdTop lcdTop0(.clk(~clk50), .rst(btn_rot),
               .userData(wd[9:0]),
               .userDataEnable(lcd_we),
               .lcdEnable(lcd_e),
               .lcdRegisterSelect(lcd_rs),
               .lcdReadWrite(lcd_rw),
               .dataBitHigh(db[7:4]),
               .dataBitLow(db[3:0]) );

endmodule
